/* sqksort - string version of qksort
 */
#define QKSORT_NAME sqksort
#define QKSORT_TYPE char *
#define QKSORT_GT(a, b) \
	((a)[0] != (b)[0] ? (a)[0] > (b)[0] : strcmp(a, b) > 0)
#include "qksort.h"
#ifdef TRYMAIN
#include <math.h>
main(ac, av)
	int ac;
	char *av[];
	{
	int i;
	int lim;
	static char * a[10000];
	static char pie[10001] = {0};
	double nlogn;
	double tim;
	long cputim();

	lim = atoi(av[1]);
	printf("lim=%d\n", lim);
	for (i = 0; i < 10000; ++i)
		pie[i] = rand() & 63;
	for (i = 0; i < lim; ++i)
		a[i] = &pie[rand() % 10000];
	cputim();
	QKSORT_NAME(a, lim);
	tim = cputim() * 1e6 / 60;
	printf("cpu time = %.3f (sec)\n", tim / 1e6);
	nlogn = lim * log((double)lim) / log(2.);
	printf("log N = %.3f\n", log((double)lim) / log(2.));
	printf("N log N = %.3f\n", nlogn);
	printf("cpu time = %.2f N log N (usec)\n", tim / nlogn);
	for (i = 0; i < lim-1; ++i)
		{
		if (QKSORT_GT(a[i], a[i+1]))
			error("bad value", "");
		}
	exit(SUCCEED);
	}
#endif
